/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package alignmentsystemexp;

/**
 *
 * @author ckr
 */
public class SvenskmandAppearance implements AppearanceStrategy{
    private double steepness;
    private double radius;
    // Adjusts how much the factional mix should influence the probability:
    // 1.0 total influence, 0.0 no influence
    private double mix;

    public SvenskmandAppearance(double steepness, double radius, double mix){
        this.steepness = steepness;
        this.radius = radius;
        this.mix = mix;
    }

    public double appearProb(Keeper keeper, Creature creature) {
        // My computation of creature appearance
        double denominator = 0.0;
        double creatureAlignDist = creature.getAlignment().LpDistance(keeper.getAlignment(), 2.0);
        double creatureAllieDist = creature.getAllies().LpDistance(keeper.getAllies(), 2.0);
        double nominator =
                (1.0 - mix) * (1.0 /(steepness * Math.pow(creatureAlignDist, radius) + 1))
                + mix * (1.0 /(steepness * Math.pow(creatureAllieDist, radius) + 1));
        for(Creature c : keeper.getCreaturePool()){
            double cAlignDist = c.getAlignment().LpDistance(keeper.getAlignment(), 2.0);
            double cAllieDist = c.getAllies().LpDistance(keeper.getAllies(), 2.0);
            denominator +=
                    (1.0 - mix) * (1.0 /(steepness * Math.pow(cAlignDist, radius) + 1))
                    + mix * (1.0 /(steepness * Math.pow(cAllieDist, radius) + 1));
        }
        return nominator/denominator;
    }
}
