/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package alignmentsystemexp;

import java.util.List;

/**
 *
 * @author ckr
 */
public class SvenskmandStatistics implements StatisticsStrategy{
    private Alignment alignment;
    private Allies allies;
    
    public void calculateStatistics(Keeper keeper, List<Creature> list) {
        Alignment creatureAlignment = new Alignment();
        Allies creatureAllies = new Allies();
        for (Creature c : list) {
            creatureAlignment = new Alignment((creatureAlignment.add(c.getAlignment())).getArray());
            Allies tmp = null;
            switch(c.getFaction()){
                case Hum:
                    tmp = new Allies(1.0, 0.0, 0.0, 0.0, 0.0, 0.0);
                    break;
                case Cor:
                    tmp = new Allies(0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
                    break;
                case Con:
                    tmp = new Allies(0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
                    break;
                case Und:
                    tmp = new Allies(0.0, 0.0, 0.0, 1.0, 0.0, 0.0);
                    break;
                case Elv:
                    tmp = new Allies(0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
                    break;
                case Mec:
                    tmp = new Allies(0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
                    break;
            }
            creatureAllies = new Allies((creatureAllies.add(tmp)).getArray());
        }
        if (list.size() > 0) {
            creatureAlignment = new Alignment((creatureAlignment.scale(1.0 / list.size())).getArray());
            creatureAllies = new Allies((creatureAllies.scale(1.0 / list.size())).getArray());
        }
        alignment = new Alignment((creatureAlignment.scale(keeper.getEvolveRate())
                .add(keeper.getAlignment().scale(1-keeper.getEvolveRate()))).getArray());
        allies = creatureAllies;
    }

    public void setStatistics(Keeper keeper, List<Creature> list) {
        if(alignment == null || allies == null){
            calculateStatistics(keeper, list);
        }
        keeper.setAlignment(alignment);
        keeper.setAllies(allies);
    }

    public Alignment getAlignment() {
        return alignment;
    }

    public Allies getAllies() {
        return allies;
    }
}
